﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'Custom View class 
#Event: ChangeValue (Value As Int)
'#DesignerProperty: Key: BooleanExample, DisplayName: Boolean Example, FieldType: Boolean, DefaultValue: True, Description: Example of a boolean property.
#DesignerProperty: Key: MinValue, DisplayName: MinValue, FieldType: Int, DefaultValue: 0, MinRange: 0, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: MaxValue, DisplayName: MaxValue, FieldType: Int, DefaultValue: 100, MinRange: 0, Description: Note that MinRange and MaxRange are optional.
#DesignerProperty: Key: Value, DisplayName: Value, FieldType: Int, DefaultValue: 0, MinRange: 0, Description: Actual value
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: Color, DisplayName: Color Example, FieldType: Color, DefaultValue: 0xFFCFDCDC, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As B4XView
	'Private Const DefaultColorConstant As Int = -984833 'ignore
	
	Private ColorSlide As Int
	Private MinValue,MaxValue As Int = 0
	Private Value As Int = 0
	
	Private PanColor As B4XView
	Private Pan As B4XView
	Private LabMin,LabMax As B4XView
	Private PanelBall As B4XView
	Private Ball As B4XView
	Private Bar As B4XView
	Private xui As XUI
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	PanColor = xui.CreatePanel("")
	Pan = xui.CreatePanel("panel")
	LabMin = CreateLabel
	LabMax = CreateLabel
	PanelBall= xui.CreatePanel("")
	Ball = CreateLabel
	Bar = CreateLabel
End Sub

Private Sub CreateLabel As B4XView
	Dim l As Label
	l.Initialize("")
	Return l
End Sub

Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	ColorSlide = xui.PaintOrColorToColor(Props.Get("Color"))
	MinValue = xui.PaintOrColorToColor(Props.Get("MinValue"))
	MaxValue= xui.PaintOrColorToColor(Props.Get("MaxValue"))
	Value=Props.Get("Value")
	
	mBase.color = xui.Color_Transparent
	PanColor.Color=ColorSlide
	Pan.Color=xui.Color_Transparent
	
	LabMin.Color=xui.Color_Transparent
	LabMin.TextColor=xui.Color_White
	LabMin.SetTextAlignment("CENTER", "CENTER")
	LabMin.Text=MinValue
	
	LabMax.Color=xui.Color_Transparent
	LabMax.TextColor=xui.Color_White
	LabMax.SetTextAlignment("CENTER", "CENTER")
	LabMax.Text=MaxValue
	
	Ball.TextColor = xui.Color_Black
	Ball.SetColorAndBorder(xui.Color_White, 10,ColorSlide,mBase.Height/4)
	Ball.SetTextAlignment("CENTER", "CENTER")
	Ball.Text=Value
	
	Bar.Color=ColorSlide
	
	PanelBall.Color=xui.Color_Transparent
	PanelBall.AddView(Bar,mBase.Height/8,mBase.Height/4,mBase.Height/4,mBase.Height/4)
	PanelBall.AddView(Ball,0,0,mBase.Height/2-1,mBase.Height/2-1)
	
	mBase.AddView(PanColor,0,mBase.Height/2,mBase.Width,mBase.Height/2)
	PanColor.AddView(LabMin,0,0,60dip,PanColor.Height)
	PanColor.AddView(LabMax,PanColor.Width-60dip,0,60dip,PanColor.Height)
	mBase.AddView(PanelBall,0,mBase.Height/2,mBase.Height/2,mBase.Height/2)
	mBase.AddView(Pan,0,mBase.Height/2,mBase.Width,mBase.Height/2)
	
	setValue(Value,False)
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub

public Sub setValue(pos As Int,Click As Boolean)
	If pos>=MinValue And pos<=MaxValue Then 
		Value=pos
		PanelBall.Left=((Value-MinValue)/(MaxValue-MinValue))*(mBase.Width-(mBase.Height/2))
		Ball.Text=pos
		If Click Then 
			PanelBall.SetLayoutAnimated(200,PanelBall.Left,3,mBase.Height/2,mBase.Height/2)
		End If
	End If
End Sub

Public Sub getValue As Int
	Return Value
End Sub

Private Sub Panel_Touch (Action As Int, X As Float, Y As Float)
	Dim P As Int = Max(Min((((x-10)/(mBase.Width-18))*(MaxValue-MinValue))+MinValue,MaxValue),MinValue)
	Select Action
		Case Pan.TOUCH_ACTION_DOWN ' ACTION_DOWN
			setValue(P,True)
			If xui.SubExists(mCallBack,mEventName & "_ChangeValue",1) Then CallSub2(mCallBack,mEventName & "_ChangeValue",p)
		Case Pan.TOUCH_ACTION_UP ' ACTION_UP
			PanelBall.SetLayoutAnimated(200,PanelBall.Left,mBase.Height/2,mBase.Height/2,mBase.Height/2)
		Case Pan.TOUCH_ACTION_MOVE ' ACTION_MOVE
			setValue(P,True)
			If xui.SubExists(mCallBack,mEventName & "_ChangeValue",1) Then CallSub2(mCallBack,mEventName & "_ChangeValue",p)
	End Select
End Sub

